package Fractals.PythagorasTree;

import java.util.LinkedList;

import Fractals.NumberCalculation.Fibonacci;

/**
 * Created by Christian on 10.02.2015.
 */
public class PythagorasTriangleList {
    private LinkedList<PythagorasTriangle> triangles = new LinkedList<PythagorasTriangle>();
    private Fibonacci fibonacci = new Fibonacci();
    private PythagorasTree.PythagorasTreeVariant variant;
    private double angle;

    public PythagorasTriangleList(PythagorasTree.PythagorasTreeVariant variant, int maximalDepth, double angle) {
        this.variant = variant;
        this.angle = angle;
        for (int i = 0; i < maximalDepth; i++) {
            triangles.add(new PythagorasTriangle(variant, i, fibonacci, angle));
        }
    }

    public double getLeftAngle(int index) {
        if (index >= triangles.size()) {
            triangles.add(new PythagorasTriangle(variant, index, fibonacci, angle));
        }
        return triangles.get(index).getLeftAngle();
    }

    public double getRightAngle(int index) {
        return triangles.get(index).getRightAngle();
    }

    public double getLeftSizeFactor(int index) {
        return triangles.get(index).getLeftSizeFactor();
    }

    public double getRightSizeFactor(int index) {
        return triangles.get(index).getRightSizeFactor();
    }
}
